{{define "title"}}
{{.Title}} - {{.Ref}}
{{end}}

{{define "content"}}
{{$p := .UrlPrefix}}
{{$authorized := .AuthorizedAsManager}}
<div class="container">
    <div class="row">
        <h1>{{.Title}}</h1>
    </div>
    <div class="row">
        {{if .PrUrl}}
        <div class="col-3">
            Ref: <a href="{{.PrUrl}}">{{.Ref}}</a>
        </div>
        {{end}}
        {{if .CommitUrl}}
        <div class="col-2">
            Commit: <a href="{{.CommitUrl}}">{{slice .SHA 0 8}}</a>
        </div>
        {{end}}
        <div class="col-2">
          {{.StartedAt}}
        </div>
        {{if or .CanRestart .CanCancel | and $authorized}}
        <div class="col-2">
            {{if .CanRestart}}
            <form action="/{{$p}}/pipeline/restart" method="post" style="display: inline">
            {{else if .CanCancel}}
            <form action="/{{$p}}/pipeline/cancel" method="post" style="display: inline">
            {{end}}
                <input type="hidden" id="redirect" name="redirect" value="{{$.RestartCancelRedirect}}">
                <input type="hidden" id="pipelineid" name="pipelineid" value="{{$.PipelineID}}">
                <input type="hidden" id="projectid" name="projectid" value="{{.ProjectID}}">
                <input type="hidden" id="gitlab_pipelineid" name="gitlab_pipelineid" value="{{.GitlabPipelineID}}">
                {{if .CanRestart}}
                <button class="btn btn-primary" type="submit" title="Restart all failed or canceled jobs">
                    <svg class="bi">
                        <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#arrow-repeat" />
                    </svg> Restart jobs
                {{else if .CanCancel}}
                <button class="btn btn-danger" type="submit" title="Cancel all running jobs">
                    <svg class="bi">
                        <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#x" />
                    </svg> Cancel running
                {{end}}
                </button>
            </form>
        </div>
        {{end}} {{/* authorized and CanRestart or CanCancel */}}
    </div>
    <hr class="border-2 border-top">
    {{range .Pipelines}}
    {{$pipeline_div := false}}
    {{if ne .Name ""}}
    <div class="row mt-2">
        <div class="col-12">
            <h3>
                <svg class="bi {{.TextColor}}">
                    <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#{{.Icon}}" />
                </svg> <a href="{{.Url}}">{{.Name}}</a>{{if .Partial}}<span style="font-size: 0.6em;"> (partial child pipeline)</span>{{end}}
            </h3>
        </div>
    </div>
    <div class="ps-4">
    {{$pipeline_div = true}}
    {{end}} {{/* Pipeline.Name != "" */}}
    {{range .Stages}}
    <div class="row mt-2">
        <div class="col-12">
            <h3>
                <svg class="bi {{.TextColor}}">
                    <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#{{.Icon}}" />
                </svg> {{.Name}}
            </h3>
        </div>
    </div>
    <div class="ps-3">
    {{ range .Jobs }}
    <div class="row">
        <div class="col-5">
            <span title="{{lower .Status}}" class="{{.TextColor}}">
                <svg class="bi">
                    <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#{{.Icon}}" />
                </svg>
            </span>
            <a class="{{if eq .Status "skipped"}}text-secondary{{end}}" href="{{.Href}}">{{.Name}}</a>
            {{if or .CanRestart .CanCancel | and $authorized}}
            {{if .CanRestart}}
            <form action="/{{$p}}/job/restart" method="post" style="display: inline">
            {{else if .CanCancel}}
            <form action="/{{$p}}/job/cancel" method="post" style="display: inline">
            {{end}}
                <input type="hidden" id="redirect" name="redirect" value="{{$.RestartCancelRedirect}}">
                <input type="hidden" id="pipelineid" name="pipelineid" value="{{$.PipelineID}}">
                <input type="hidden" id="projectid" name="projectid" value="{{$.ProjectID}}">
                <input type="hidden" id="jobid" name="jobid" value="{{.JobID}}">
                {{if .CanRestart}}
                <button class="btn btn-sm" type="submit" title="Restart job">
                    <svg class="bi">
                        <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#arrow-repeat" />
                    </svg>
                {{else if .CanCancel}}
                <button class="btn btn-sm" type="submit" title="Cancel job">
                    <svg class="bi">
                        <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#x" />
                    </svg>
                {{end}}
                </button>
            </form>
            {{end}} {{/* $authorized and CanRestart or CanCancel */}}
            {{if len .ArtifactsHref | lt 0}}
            <a class="ms-2" href="{{.ArtifactsHref}}">
                <span title="Download artifacts.zip">
                    <svg class="bi">
                        <use xlink:href="/{{$p}}/static/img/bootstrap-icons.svg#download" />
                    </svg>
                </span>
            </a>
            {{end}} {{/* artifacts */}}
        </div>
        <div class="col-2 text-secondary">{{.Duration}}</div>
        <div class="col-2 text-secondary">{{.StartedAt}}</div>
    </div>
    {{if eq .Status "manual" | and $authorized}}
    <form action="/{{$p}}/job/play" method="post">
        <div class="row align-items-end">
            <input type="hidden" id="redirect" name="redirect" value="{{$.RestartCancelRedirect}}">
            <input type="hidden" id="pipelineid" name="pipelineid" value="{{$.PipelineID}}">
            <input type="hidden" id="projectid" name="projectid" value="{{$.ProjectID}}">
            <input type="hidden" id="jobid" name="jobid" value="{{.JobID}}">
            <div class="col-6">
                <label for="jobvars">Variables for job <code>{{.Name}}</code></label>
                <textarea id="jobvars" name="jobvars" class="form-control" rows="3" placeholder="MY_VAR_1: MY_VALUE_1&#10;MY_VAR_2: MY_VALUE_2"></textarea>
            </div>
            <div class="col-2">
                <button class="btn btn-secondary">Start manual job</button>
            </div>
        </div>
    </form>
    {{end}} {{/* manual job and authorized */}}
    {{end}} {{/* range .Jobs */}}
    </div>
    {{end}} {{/* range .Stages */}}
    {{if $pipeline_div}}</div>{{end}}
    {{end}} {{/* range .Pipelines */}}
</div>
{{if len .LoginURL | lt 0}}
<a href="{{.LoginURL}}" style="position:fixed; bottom:10px; right:10px">Login to restart jobs</a>
{{end}}
{{end}} {{/* define "content" */}}

{{- template "base" . -}}
